(function() {
    tinymce.PluginManager.add('GSPIN_mce_button', function( editor, url ) {
        editor.addButton( 'GSPIN_mce_button', {
            title: 'GS Pinterest Portfolio',
            type: 'button',
            icon: 'icon gspin-mce-icon',
            onclick: function() {
                editor.windowManager.open( {
                    title: 'Insert Pinterest Info ',
                    body: [{
                        type: 'textbox',
                        name: 'UserId',
                        label: 'Pinterest User Id',
                        placeholder:'Add Id here'
                    },

                    {
                        type: 'textbox',
                        name: 'UserBoard',
                        label: 'User Board (optional)',
                        placeholder:'Add Board here'
                    },

                    {
                        type: 'textbox',
                        name: 'Count',
                        label: 'Number of Pins',
                        value:'10'
                    },
                    
                    {
                        type: 'listbox', 
                        name: 'theme', 
                        label: 'Theme', 
                        'values': [
                            {text: 'Theme 1 (Pins)', value: 'gs_pin_theme1'},
                            {text: 'Theme 2 (Pin with Links)', value: 'gs_pin_theme2'},
                            {text: 'Theme 3 (Hover)', value: 'gs_pin_theme3'},
                            {text: 'Theme 4 (Popup)', value: 'gs_pin_theme4'},
                            {text: 'Theme 5 (Greyscale)', value: 'gs_pin_theme5'}                         
                        ]
                    },

                    {
                        type: 'listbox', 
                        name: 'col', 
                        label: 'Column', 
                        'values': [
                            {text: '3 Columns', value: '3'},
                            {text: '4 Columns', value: '4'},
                            {text: '5 Columns', value: '5'},
                            {text: '6 Columns', value: '6'}                        
                        ]
                    }

                    ],
                    onsubmit: function( e ) {
                        editor.insertContent( '[gs_pinterest user="' + e.data.UserId + '" board="' + e.data.UserBoard + '" count="' + e.data.Count + '" theme="' + e.data.theme + '" cols="' + e.data.col + '"]');
                    }
                });
    }
        });
    });
})();