<?php 
/**
 *
 * @package   GS_Pinterest_Portfolio
 * @author    Golam Samdani <samdani1997@gmail.com>
 * @license   GPL-2.0+
 * @link      http://www.gsamdani.com
 * @copyright 2016 Golam Samdani
 *
 * @wordpress-plugin
 * Plugin Name:			GS Pinterest Portfolio PRO
 * Plugin URI:			http://www.gsamdani.com/wordpress-plugins
 * Description:       	Best Responsive Pinterest plugin for Wordpress to showcase Pinterest Pins. Display anywhere at your site using shortcode like [gs_pinterest] & widgets. Check more shortcode examples and documentation at <a href="http://www.pinterest.gsamdani.com">GS Pinterest Porfolio PRO Demos & Docs</a>
 * Version:           	2.0.3
 * Author:       		Golam Samdani
 * Author URI:       	http://www.gsamdani.com
 * Text Domain:       	gs-pinterest
 * License:           	GPL-2.0+
 * License URI:       	http://www.gnu.org/licenses/gpl-2.0.txt
*/

if( ! defined( 'GSBEH_HACK_MSG' ) ) define( 'GSBEH_HACK_MSG', __( 'Sorry cowboy! This is not your place', 'gs-pinterest' ) );

/**
 * Protect direct access
 */
if ( ! defined( 'ABSPATH' ) ) die( GSBEH_HACK_MSG );

/**
 * Defining constants
 */
if( ! defined( 'GSPIN_VERSION' ) ) define( 'GSPIN_VERSION', '2.0.3' );
if( ! defined( 'GSPIN_MENU_POSITION' ) ) define( 'GSPIN_MENU_POSITION', 31 );
if( ! defined( 'GSPIN_PLUGIN_DIR' ) ) define( 'GSPIN_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
if( ! defined( 'GSPIN_FILES_DIR' ) ) define( 'GSPIN_FILES_DIR', GSPIN_PLUGIN_DIR . 'gs-pinterest-assets' );
if( ! defined( 'GSPIN_PLUGIN_URI' ) ) define( 'GSPIN_PLUGIN_URI', plugins_url( '', __FILE__ ) );
if( ! defined( 'GSPIN_FILES_URI' ) ) define( 'GSPIN_FILES_URI', GSPIN_PLUGIN_URI . '/gs-pinterest-assets' );

define('GSPINTEREST_PLUGIN_FILE', __FILE__ );
// $status  = get_option( 'GS_PINTEREST_LICENSE_STATUS' );

require_once GSPIN_FILES_DIR . '/gs-plugins/gs-plugins.php';
require_once GSPIN_FILES_DIR . '/gs-plugins/gs-plugins-free.php';
// if( $status !== false && $status == 'valid' ) {
	require_once GSPIN_FILES_DIR . '/includes/gs-pin-function.php';
	require_once GSPIN_FILES_DIR . '/includes/gs-pinterest-shortcode.php';
	require_once GSPIN_FILES_DIR . '/includes/gs-single-pin-widgets.php';
	require_once GSPIN_FILES_DIR . '/includes/gs-follow-pin-widgets.php';
	require_once GSPIN_FILES_DIR . '/includes/gs-pin-boards-widget.php';
	require_once GSPIN_FILES_DIR . '/includes/gs-pin-profile-widget.php';
	require_once GSPIN_FILES_DIR . '/admin/class.settings-api.php';
	require_once GSPIN_FILES_DIR . '/admin/gs_pinterest_options_config.php';
	require_once GSPIN_FILES_DIR . '/gs-pinterest-scripts.php';
// }
// require_once GSPIN_FILES_DIR . '/gs-plugins/lic/gs_pinterest_lic.php';
require_once GSPIN_FILES_DIR . '/gs-plugins/gs-pin-help.php';

// MCE button
add_action( 'init', 'GSPIN_buttons' );
function GSPIN_buttons() {
    add_filter( "mce_external_plugins", "GSPIN_add_buttons" );
    add_filter( 'mce_buttons', 'GSPIN_register_buttons' );
}
function GSPIN_add_buttons( $plugin_array ) {
    $plugin_array['GSPIN_mce_button'] = GSPIN_FILES_URI . '/assets/js/gspin-mce.js';
    return $plugin_array;
}
function GSPIN_register_buttons( $buttons ) {
    array_push( $buttons, 'GSPIN_mce_button' );
    return $buttons;
}

// -- Admin css
function gspin_enque_admin_style() {
    $media = 'all';

    wp_register_style( 'gspin-admin-style', GSPIN_FILES_URI . '/admin/css/gspin_admin_style.css', '', GSPIN_VERSION, $media );
    wp_enqueue_style( 'gspin-admin-style' );

    wp_register_style( 'gspin-free-plugins-style', GSPIN_FILES_URI . '/admin/css/gs_free_plugins.css', '', GSPIN_VERSION, $media );
    wp_enqueue_style( 'gspin-free-plugins-style' );
}
add_action( 'admin_enqueue_scripts', 'gspin_enque_admin_style' );


/**
 * Activation redirects
 *
 * @since v1.0.0
 */
function gspin_activate() {
    add_option('gspin_activation_redirect', true);
}
register_activation_hook(__FILE__, 'gspin_activate');

/**
 * Redirect to options page
 *
 * @since v1.0.0
 */
function gspin_redirect() {
    if (get_option('gspin_activation_redirect', false)) {
        delete_option('gspin_activation_redirect');
        if(!isset($_GET['activate-multi']))
        {
            
            wp_redirect("admin.php?page=gs-pin-help");
        }
    }
}
add_action('admin_init', 'gspin_redirect');


/**
 * @review_dismiss()
 * @review_pending()
 * @gspin_review_notice_message()
 * Make all the above functions working.
 */
function gspin_review_notice(){

    gspin_review_dismiss();
    gspin_review_pending();

    $activation_time    = get_site_option( 'gspin_active_time' );
    $review_dismissal   = get_site_option( 'gspin_review_dismiss' );
    $maybe_later        = get_site_option( 'gspin_maybe_later' );

    if ( 'yes' == $review_dismissal ) {
        return;
    }

    if ( ! $activation_time ) {
        add_site_option( 'gspin_active_time', time() );
    }
    
    $daysinseconds = 259200; // 3 Days in seconds.
   
    if( 'yes' == $maybe_later ) {
        $daysinseconds = 604800 ; // 7 Days in seconds.
    }

    if ( time() - $activation_time > $daysinseconds ) {
        add_action( 'admin_notices' , 'gspin_review_notice_message' );
    }
}
add_action( 'admin_init', 'gspin_review_notice' );

/**
 * For the notice preview.
 */
function gspin_review_notice_message(){
    $scheme      = (parse_url( $_SERVER['REQUEST_URI'], PHP_URL_QUERY )) ? '&' : '?';
    $url         = $_SERVER['REQUEST_URI'] . $scheme . 'gspin_review_dismiss=yes';
    $dismiss_url = wp_nonce_url( $url, 'gspin-review-nonce' );

    $_later_link = $_SERVER['REQUEST_URI'] . $scheme . 'gspin_review_later=yes';
    $later_url   = wp_nonce_url( $_later_link, 'gspin-review-nonce' );
    ?>
    
    <div class="gslogo-review-notice">
        <div class="gslogo-review-thumbnail">
            <img src="<?php echo GSPIN_FILES_URI . '/assets/img/icon-128x128.png' ?>" alt="">
        </div>
        <div class="gslogo-review-text">
            <h3><?php _e( 'Leave A Review?', 'gs-pinterest' ) ?></h3>
            <p><?php _e( 'We hope you\'ve enjoyed using <b>GS Pinterest Portfolio</b>! Would you consider leaving us a review on WordPress.org?', 'gs-pinterest' ) ?></p>
            <ul class="gslogo-review-ul">
                <li>
                    <a href="https://wordpress.org/support/plugin/gs-pinterest-portfolio/reviews/" target="_blank">
                        <span class="dashicons dashicons-external"></span>
                        <?php _e( 'Sure! I\'d love to!', 'gs-pinterest' ) ?>
                    </a>
                </li>
                <li>
                    <a href="<?php echo $dismiss_url ?>">
                        <span class="dashicons dashicons-smiley"></span>
                        <?php _e( 'I\'ve already left a review', 'gs-pinterest' ) ?>
                    </a>
                </li>
                <li>
                    <a href="<?php echo $later_url ?>">
                        <span class="dashicons dashicons-calendar-alt"></span>
                        <?php _e( 'Maybe Later', 'gs-pinterest' ) ?>
                    </a>
                </li>
                <li>
                    <a href="https://www.gsamdani.com/support/" target="_blank">
                        <span class="dashicons dashicons-sos"></span>
                        <?php _e( 'I need help!', 'gs-pinterest' ) ?>
                    </a>
                </li>
                <li>
                    <a href="<?php echo $dismiss_url ?>">
                        <span class="dashicons dashicons-dismiss"></span>
                        <?php _e( 'Never show again', 'gs-pinterest' ) ?>
                    </a>
                </li>
            </ul>
        </div>
    </div>
    
    <?php
}

/**
 * For Dismiss! 
 */
function gspin_review_dismiss(){

    if ( ! is_admin() ||
        ! current_user_can( 'manage_options' ) ||
        ! isset( $_GET['_wpnonce'] ) ||
        ! wp_verify_nonce( sanitize_key( wp_unslash( $_GET['_wpnonce'] ) ), 'gspin-review-nonce' ) ||
        ! isset( $_GET['gspin_review_dismiss'] ) ) {

        return;
    }

    add_site_option( 'gspin_review_dismiss', 'yes' );   
}

/**
 * For Maybe Later Update.
 */
function gspin_review_pending() {

    if ( ! is_admin() ||
        ! current_user_can( 'manage_options' ) ||
        ! isset( $_GET['_wpnonce'] ) ||
        ! wp_verify_nonce( sanitize_key( wp_unslash( $_GET['_wpnonce'] ) ), 'gspin-review-nonce' ) ||
        ! isset( $_GET['gspin_review_later'] ) ) {

        return;
    }
    // Reset Time to current time.
    update_site_option( 'gspin_active_time', time() );
    update_site_option( 'gspin_maybe_later', 'yes' );

}

/**
 * Remove Reviews Metadata on plugin Deactivation.
 */
function gspin_deactivate() {
    delete_option('gspin_active_time');
    delete_option('gspin_maybe_later');
}
register_deactivation_hook(__FILE__, 'gspin_deactivate');